#!/usr/bin/env python

# This application is released under the GNU General Public License 
# v3 (or, at your option, any later version). You can find the full 
# text of the license under http://www.gnu.org/licenses/gpl.txt. 
# By using, editing and/or distributing this software you agree to 
# the terms and conditions of this license. 
# Thank you for using free software!
#
#(c) QB89Dragon 2007/8 <hughescih@hotmail.com>
#(c) Whise 2008 <helderfraga@gmail.com>
#
# Desktop Integration v 1.00
# This does not run on it's own
# This module is designed to by updated along with versions of gnome and compiz as key values change

import gconf
import gtk

class DesktopIntegration():
	def __init__(self):
		self.gconf_client = gconf.client_get_default()
		
	def enable(self,index):
		index = int(index)
		if index == 0:
			# Focus steal prevention for compiz(full) and metacity(partial)
			if self.checkcompositing():
				self.gconf_client.set_string("/apps/compiz/general/screen0/options/focus_prevention_match", " & !(type=Menu)")
			else:
				self.gconf_client.set_string("/apps/metacity/general/focus_new_windows", "strict")
		elif index == 1:			
			self.gconf_client.set_string("/apps/compiz/plugins/decoration/allscreens/options/shadow_match", " & !(type=Dock)")
		elif index == 2:
			# Non Destructive Method
			TypeList = self.gconf_client.get_list("/apps/compiz/general/screen0/options/opacity_matches",gconf.VALUE_STRING)
			ValList = self.gconf_client.get_list("/apps/compiz/general/screen0/options/opacity_values",gconf.VALUE_INT)
			TypeList.append("type=Dock")
			ValList.append(80)
			self.gconf_client.set_list("/apps/compiz/general/screen0/options/opacity_matches",gconf.VALUE_STRING,TypeList)
			self.gconf_client.set_list("/apps/compiz/general/screen0/options/opacity_values",gconf.VALUE_INT,ValList)
		elif index == 3:
			# Non Destructive Method
			TypeList = self.gconf_client.get_list("/apps/compiz/general/screen0/options/opacity_matches",gconf.VALUE_STRING)
			ValList = self.gconf_client.get_list("/apps/compiz/general/screen0/options/opacity_values",gconf.VALUE_INT)
			TypeList.append("type=Menu")
			ValList.append(80)
			self.gconf_client.set_list("/apps/compiz/general/screen0/options/opacity_matches",gconf.VALUE_STRING,TypeList)
			self.gconf_client.set_list("/apps/compiz/general/screen0/options/opacity_values",gconf.VALUE_INT,ValList)

	def disable(self, index):
		index = int(index)
		if index == 0:
			# Focus steal prevention for compiz(full) and metacity(partial)
			if self.checkcompositing():
				self.gconf_client.set_string("/apps/compiz/general/screen0/options/focus_prevention_match", "any")
			else:
				self.gconf_client.set_string("/apps/metacity/general/focus_new_windows", "smart")
		elif index == 1:
			self.gconf_client.set_string("/apps/compiz/plugins/decoration/allscreens/options/shadow_match", "any")
		elif index == 2:
			# Non Destructive Method
			TypeList = self.gconf_client.get_list("/apps/compiz/general/screen0/options/opacity_matches",gconf.VALUE_STRING)
			ValList = self.gconf_client.get_list("/apps/compiz/general/screen0/options/opacity_values",gconf.VALUE_INT)
			if TypeList != []:
				for i in range(0,len(TypeList)):
					if TypeList[i] == "type=Dock":
						TypeList.remove("type=Dock")
						ValList.remove(ValList[i])
						break
			self.gconf_client.set_list("/apps/compiz/general/screen0/options/opacity_matches",gconf.VALUE_STRING,TypeList)
			self.gconf_client.set_list("/apps/compiz/general/screen0/options/opacity_values",gconf.VALUE_INT,ValList)
		elif index == 3:
			# Non Destructive Method
			TypeList = self.gconf_client.get_list("/apps/compiz/general/screen0/options/opacity_matches",gconf.VALUE_STRING)
			ValList = self.gconf_client.get_list("/apps/compiz/general/screen0/options/opacity_values",gconf.VALUE_INT)
			if TypeList != []:
				for i in range(0,len(TypeList)):
					if TypeList[i] == "type=Menu":
						TypeList.remove("type=Menu")
						ValList.remove(ValList[i])
						break
			self.gconf_client.set_list("/apps/compiz/general/screen0/options/opacity_matches",gconf.VALUE_STRING,TypeList)
			self.gconf_client.set_list("/apps/compiz/general/screen0/options/opacity_values",gconf.VALUE_INT,ValList)

	def checkstate(self,index):
		index = int(index)
		if index == 0:
			# Focus steal prevention for compiz(full) and metacity(partial)
			if self.checkcompositing():
				if self.gconf_client.get_string("/apps/compiz/general/screen0/options/focus_prevention_match") == " & !(type=Menu)":
					return True
				else:
					return False
			else:
				if self.gconf_client.get_string("/apps/metacity/general/focus_new_windows") == "strict":
					return True
				else:
					return False
		elif index == 1:
			if self.gconf_client.get_string("/apps/compiz/plugins/decoration/allscreens/options/shadow_match") == " & !(type=Dock)":
				return True
			else:
				return False
				
		elif index == 2:
			TypeList = self.gconf_client.get_list("/apps/compiz/general/screen0/options/opacity_matches",gconf.VALUE_STRING)
			ValList = self.gconf_client.get_list("/apps/compiz/general/screen0/options/opacity_values",gconf.VALUE_INT)
			if TypeList != []:
				for i in range(0,len(TypeList)):
					if TypeList[i] == "type=Dock" and ValList[i] < 100:
						return True
			return False
			
		elif index == 3:
			TypeList = self.gconf_client.get_list("/apps/compiz/general/screen0/options/opacity_matches",gconf.VALUE_STRING)
			ValList = self.gconf_client.get_list("/apps/compiz/general/screen0/options/opacity_values",gconf.VALUE_INT)
			if TypeList != []:
				for i in range(0,len(TypeList)):
					if TypeList[i] == "type=Menu" and ValList[i] < 100:
						return True
			return False
		
	def checkcompositing(self):
		# Calling this tells us if we are in a compositing desktop environment or not
		return gtk.gdk.screen_get_default().is_composited()
