#!/usr/bin/env python

# This application is released under the GNU General Public License 
# v3 (or, at your option, any later version). You can find the full 
# text of the license under http://www.gnu.org/licenses/gpl.txt. 
# By using, editing and/or distributing this software you agree to 
# the terms and conditions of this license. 
# Thank you for using free software!
#
#(c) QB89Dragon 2007/8 <hughescih@hotmail.com>
#(c) Whise 2008 <helderfraga@gmail.com>
#
# Global menu settings


import gtk
import gc
import os
import xml.dom.minidom
import gconf
import sys
from DesktopIntegration import DesktopIntegration
# Fixme: Implement new component registration
try:
	INSTALL_PREFIX = open("/etc/gnomenu/prefix").read()[:-1] 
except:
	INSTALL_PREFIX = '/usr'
global name,version,appdirname 
name = "GnoMenu"
version = "1.9.9"
appdirname="gnomenu"
# Set up global directories
HomeDirectory = os.path.expanduser("~")
AutoStartDirectory = HomeDirectory + '/.config/autostart/'
ProgramDirectory = INSTALL_PREFIX + "/lib/"+appdirname+"/" 
ThemeDirectory = INSTALL_PREFIX + "/share/"+appdirname+"/Themes/"
GraphicsDirectory = INSTALL_PREFIX + "/lib/"+appdirname+"/graphics/"  
GladeSettingsFile = INSTALL_PREFIX + "/lib/"+appdirname+"/settings-window.glade"  
# Definitions
ThemeCategories = ["Menu","Icon","Button"]
gconf_app_key = '/apps/gnomenu'

def _(s):
	return s

def LoadDefaults():
	gconf_client = gconf.client_get_default()
	gconf_client.set_string(gconf_app_key + "/Menu_Name","Kore")
	gconf_client.set_int(gconf_app_key + "/IconSize",32)
	gconf_client.set_int(gconf_app_key + "/ListSize",10)
	gconf_client.set_int(gconf_app_key + "/SuperL",1)
	#gconf_client.set_string(gconf_app_key + "/Color","white")
	gconf_client.set_string(gconf_app_key + "/Icon_Name","Newstyles")
	gconf_client.set_string(gconf_app_key + "/Button_Name","GnoBlue")
	#gconf_client.set_int(gconf_app_key + "/ShowTop",1)
	#gconf_client.set_float(gconf_app_key + "/Animation_TransitionS",0.05)
	#gconf_client.set_float(gconf_app_key + "/Animation_TransitionQ",40.0)
	gconf_client.set_int(gconf_app_key + "/Shownetandemail",1)
	gconf_client.set_int(gconf_app_key + "/GtkColors",0)
	gconf_client.set_int(gconf_app_key + "/TabHover",0)

	gconf_client.set_string(gconf_app_key + "/Search","tracker-search-tool")
	gconf_client.set_string(gconf_app_key + "/Network_Config","nm-connection-editor")
	gconf_client.set_string(gconf_app_key + "/Control_Panel","gnome-control-center")
	gconf_client.set_string(gconf_app_key + "/Package_Manager","gksu synaptic")
	gconf_client.set_string(gconf_app_key + "/Help", "yelp")
	gconf_client.set_string(gconf_app_key + "/Power","gnome-session-save --shutdown-dialog")
	gconf_client.set_string(gconf_app_key + "/Lock","gnome-screensaver-command --lock")
	gconf_client.set_string(gconf_app_key + "/Run",ProgramDirectory + "Gnome_run_dialog.py")
	gconf_client.set_string(gconf_app_key + "/Logout","gnome-session-save --logout-dialog")
	gconf_client.set_string(gconf_app_key + "/Restart","/usr/bin/gnome-power-cmd reboot")
	Menu_Name = Theme = gconf_client.get_string(gconf_app_key + "/Menu_Name")
	IconSize = Isize = gconf_client.get_int(gconf_app_key + "/IconSize")
	ListSize = gconf_client.get_int(gconf_app_key + "/ListSize")
	SuperL = gconf_client.get_int(gconf_app_key + "/SuperL")
	ThemeColor = 'white'#gconf_client.get_string(gconf_app_key + "/Color")
	IconTheme = gconf_client.get_string(gconf_app_key + "/Icon_Name")
	MenuButtonTheme = gconf_client.get_string(gconf_app_key + "/Button_Name")
	ShowTop = 1#gconf_client.get_int(gconf_app_key + "/ShowTop")
	PGTheme = "Classic"
	TransitionS = 25 #gconf_client.get_float(gconf_app_key + "/Animation_TransitionS")
	TransitionQ = 0.05 #gconf_client.get_float(gconf_app_key + "/Animation_TransitionQ")
	Shownetandemail = gconf_client.get_int(gconf_app_key + "/Shownetandemail")
	GtkColors = gconf_client.get_int(gconf_app_key + "/GtkColors")
	TabHover = gconf_client.get_int(gconf_app_key + "/TabHover")
	Search = gconf_client.get_string(gconf_app_key + "/Search")
	Network_Config = gconf_client.get_string(gconf_app_key + "/Network_Config")
	Control_Panel = gconf_client.get_string(gconf_app_key + "/Control_Panel")
	Package_Manager = gconf_client.get_string(gconf_app_key + "/Package_Manager")
	Help = gconf_client.get_string(gconf_app_key + "/Help")
	Power = gconf_client.get_string(gconf_app_key + "/Power")
	Lock = gconf_client.get_string(gconf_app_key + "/Lock")
	Run = ProgramDirectory + "Gnome_run_dialog.py"
	ClearRecent = 'python -u ' +ProgramDirectory + "clean-recently-used.py -R"
	Logout = gconf_client.get_string(gconf_app_key + "/Logout")
	Restart = gconf_client.get_string(gconf_app_key + "/Restart")
	MenuActions = []
	MenuCommands = []
	MenuActions.append('Search')
	MenuCommands.append(Search)
	MenuActions.append('Network_Config')
	MenuCommands.append(Network_Config)
	MenuActions.append('Control_Panel')
	MenuCommands.append(Control_Panel)
	MenuActions.append('Package_Manager')
	MenuCommands.append(Package_Manager)
	MenuActions.append('Help')
	MenuCommands.append(Help)
	MenuActions.append('Power')
	MenuCommands.append(Power)
	MenuActions.append('Lock')
	MenuCommands.append(Lock)
	MenuActions.append('Run')
	MenuCommands.append(Run)
	MenuActions.append('Logout')
	MenuCommands.append(Logout)
	MenuActions.append('Restart')
	MenuCommands.append(Restart)



# Load settings stored in XML
def ReloadSettings():
	global orientation,panel_size,flip
	orientation = None
	panel_size = 30
	flip = None
	gconf_client = gconf.client_get_default()
	orientation = gconf_client.get_string(gconf_app_key + '/orientation')
	panel_size = gconf_client.get_int(gconf_app_key + '/size')
	if orientation == 'top':
		flip = False
	elif orientation == 'bottom':
		flip = None
	while gtk.events_pending():
		gtk.main_iteration()
	
	# Loads the main configuration and settings file to their respective values
	global MenuActions,Theme, MenuCommands, Language, Isize,IconSize,ListSize,ImageDirectory,Actions, IconTheme, IconDirectory, GladeFile,MenuButtonTheme,MenuButtonDirectory,ThemeColor,ShowTop,TransitionQ,TransitionS,PGTheme,GtkColors,TabHover, Shownetandemail,FirstUse,SuperL,Search,Network_Config,Control_Panel,Package_Manager,Help,Power,Lock,Run, Logout, Restart, ClearRecent
	FirstUse = False
	Menu_Name = Theme = gconf_client.get_string(gconf_app_key + "/Menu_Name")
	IconSize = Isize = gconf_client.get_int(gconf_app_key + "/IconSize")
	ListSize = gconf_client.get_int(gconf_app_key + "/ListSize")
	SuperL = gconf_client.get_int(gconf_app_key + "/SuperL")
	ThemeColor = 'white'#gconf_client.get_string(gconf_app_key + "/Color")
	IconTheme = gconf_client.get_string(gconf_app_key + "/Icon_Name")
	MenuButtonTheme = gconf_client.get_string(gconf_app_key + "/Button_Name")
	ShowTop = 1#gconf_client.get_int(gconf_app_key + "/ShowTop")
	PGTheme = "Classic"
	TransitionS = 25 #gconf_client.get_float(gconf_app_key + "/Animation_TransitionS")
	TransitionQ = 0.05 #gconf_client.get_float(gconf_app_key + "/Animation_TransitionQ")
	Shownetandemail = gconf_client.get_int(gconf_app_key + "/Shownetandemail")
	GtkColors = gconf_client.get_int(gconf_app_key + "/GtkColors")
	TabHover = gconf_client.get_int(gconf_app_key + "/TabHover")
	Search = gconf_client.get_string(gconf_app_key + "/Search")
	Network_Config = gconf_client.get_string(gconf_app_key + "/Network_Config")
	Control_Panel = gconf_client.get_string(gconf_app_key + "/Control_Panel")
	Package_Manager = gconf_client.get_string(gconf_app_key + "/Package_Manager")
	Help = gconf_client.get_string(gconf_app_key + "/Help")
	Power = gconf_client.get_string(gconf_app_key + "/Power")
	Lock = gconf_client.get_string(gconf_app_key + "/Lock")
	Run = ProgramDirectory + "Gnome_run_dialog.py"
	ClearRecent = 'python -u ' +ProgramDirectory + "clean-recently-used.py -R"
	Logout = gconf_client.get_string(gconf_app_key + "/Logout")
	Restart = gconf_client.get_string(gconf_app_key + "/Restart")
	if Menu_Name == None or Restart == None or Logout == None or Run == None or Lock == None or Power == None or Help == None or Package_Manager == None or Control_Panel == None or Network_Config == None or Search == None or GtkColors == None or TabHover == None or Shownetandemail == None or TransitionQ == None or TransitionS == None or PGTheme == None or MenuButtonTheme == None or IconTheme == None or ThemeColor == None or SuperL == None or ListSize == None or IconSize == None or Theme == None:
		LoadDefaults()
		FirstUse = True
		Menu_Name = Theme = gconf_client.get_string(gconf_app_key + "/Menu_Name")
		IconSize = Isize = gconf_client.get_int(gconf_app_key + "/IconSize")
		ListSize = gconf_client.get_int(gconf_app_key + "/ListSize")
		SuperL = gconf_client.get_int(gconf_app_key + "/SuperL")
		ThemeColor = 'white'#gconf_client.get_string(gconf_app_key + "/Color")
		IconTheme = gconf_client.get_string(gconf_app_key + "/Icon_Name")
		MenuButtonTheme = gconf_client.get_string(gconf_app_key + "/Button_Name")
		ShowTop = 1#gconf_client.get_int(gconf_app_key + "/ShowTop")
		PGTheme = "Classic"
		TransitionS = 25 #gconf_client.get_float(gconf_app_key + "/Animation_TransitionS")
		TransitionQ = 0.05 #gconf_client.get_float(gconf_app_key + "/Animation_TransitionQ")
		Shownetandemail = gconf_client.get_int(gconf_app_key + "/Shownetandemail")
		GtkColors = gconf_client.get_int(gconf_app_key + "/GtkColors")
		TabHover = gconf_client.get_int(gconf_app_key + "/TabHover")	
		Search = gconf_client.get_string(gconf_app_key + "/Search")
		Network_Config = gconf_client.get_string(gconf_app_key + "/Network_Config")
		Control_Panel = gconf_client.get_string(gconf_app_key + "/Control_Panel")
		Package_Manager = gconf_client.get_string(gconf_app_key + "/Package_Manager")
		Help = gconf_client.get_string(gconf_app_key + "/Help")
		Power = gconf_client.get_string(gconf_app_key + "/Power")
		Lock = gconf_client.get_string(gconf_app_key + "/Lock")
		Run = ProgramDirectory + "Gnome_run_dialog.py"
		ClearRecent = 'python -u ' +ProgramDirectory + "clean-recently-used.py -R"
		Logout = gconf_client.get_string(gconf_app_key + "/Logout")
		Restart = gconf_client.get_string(gconf_app_key + "/Restart")

	MenuActions = []
	MenuCommands = []
	MenuActions.append('Search')
	MenuCommands.append(Search)
	MenuActions.append('Network Config')
	MenuCommands.append(Network_Config)
	MenuActions.append('Control Panel')
	MenuCommands.append(Control_Panel)
	MenuActions.append('Package Manager')
	MenuCommands.append(Package_Manager)
	MenuActions.append('Help')
	MenuCommands.append(Help)
	MenuActions.append('Power')
	MenuCommands.append(Power)
	MenuActions.append('Lock')
	MenuCommands.append(Lock)
	MenuActions.append('Run')
	MenuCommands.append(Run)
	MenuActions.append('Logout')
	MenuCommands.append(Logout)
	MenuActions.append('Restart')
	MenuCommands.append(Restart)




	ImageDirectory = INSTALL_PREFIX + "/share/"+appdirname+"/Themes/Menu/"+Theme+"/"
	IconDirectory = INSTALL_PREFIX + "/share/"+appdirname+"/Themes/Icon/"+IconTheme+"/"
	MenuButtonDirectory = INSTALL_PREFIX + "/share/"+appdirname+"/Themes/Button/"+MenuButtonTheme+"/"



	#================================================================
	global PG_iconsize,RI_numberofitems
	#Size of icons in the program list (default is 24)
	PG_iconsize = int(float(Isize))
	#Recent Items Menu
	RI_numberofitems = int(float(ListSize))

	#================================================================
	# Variables created here FIXME: create object for this, it's messy like this!
	global StartMenuTemplate,ThemeColorCode,MenuWidth, MenuHeight, IconW, IconH, IconInX, IconInY, IconInW, IconInH, SearchX, SearchY, SearchW, SearchH, SearchIX, SearchIY, SearchInitialText,SearchTextColor, SearchBackground, SearchWidget, SearchWidgetPath, UserIconFrameOffsetX, UserIconFrameOffsetY,UserIconFrameOffsetH, UserIconFrameOffsetW,PG_buttonframe,PG_buttonframedimensions,MenuHasSearch, MenuHasIcon, MenuHasFade , OnlyShowFavs, CairoSearchTextColor, CairoSearchBackColor, CairoSearchBorderColor,CairoSearchRoundAngle

	try:
		XMLSettings = xml.dom.minidom.parse(ImageDirectory+"themedata.xml")
	except:
		LoadDefaults()
		XMLSettings = xml.dom.minidom.parse(ImageDirectory+"themedata.xml")
	XContent = XMLSettings.childNodes[0].getElementsByTagName("theme")
	# Identify correct theme style element
	Found = 0
	for node in XContent:
		if node.attributes["color"].value == ThemeColor or node.attributes["color"].value == "All":
			XBase = node
			ThemeColorCode = node.attributes["colorvalue"].value
			Found = 1
	if Found==0:
		print "Error: Failed to find theme color:" + ThemeColor
		print "The available values are:"
		for node in XContent:
			print node.attributes["color"].value
		sys.exit()
		
	# Load Background Image
	SBase = XBase.getElementsByTagName("Background")
	StartMenuTemplate = SBase[0].attributes["Image"].value
	

	# Load WindowDimensions
	SBase = XBase.getElementsByTagName("WindowDimensions")
	MenuWidth = int(SBase[0].attributes["Width"].value)
	MenuHeight = int(SBase[0].attributes["Height"].value)

	# Load WindowDimensions
	SBase = XBase.getElementsByTagName("IconSettings")
	UserIconFrameOffsetX = int(SBase[0].attributes["X"].value)
	UserIconFrameOffsetH = int(SBase[0].attributes["Width"].value)
	UserIconFrameOffsetW = int(SBase[0].attributes["Height"].value)
	if orientation == 'botton':
		UserIconFrameOffsetY = int(SBase[0].attributes["Y"].value)

	elif orientation == 'top':

		UserIconFrameOffsetY =  MenuHeight - int(SBase[0].attributes["Y"].value) - UserIconFrameOffsetH
	else:
		UserIconFrameOffsetY = int(SBase[0].attributes["Y"].value)

	IconW = int(SBase[0].attributes["Width"].value)
	IconH = int(SBase[0].attributes["Height"].value)
	IconInX = int(SBase[0].attributes["InsetX"].value)
	IconInY = int(SBase[0].attributes["InsetY"].value)
	IconInW = int(SBase[0].attributes["InsetWidth"].value)
	IconInH = int(SBase[0].attributes["InsetHeight"].value)

	# Load SearchBarSettings
	SBase = XBase.getElementsByTagName("SearchBarSettings")
	SearchWidget = SBase[0].attributes["Widget"].value
	if SearchWidget != "None":
		# Load universal values
		SearchX = int(SBase[0].attributes["X"].value)
		SearchW = int(SBase[0].attributes["Width"].value)
		SearchH = int(SBase[0].attributes["Height"].value)
		if orientation == 'bottom':
			SearchY = int(SBase[0].attributes["Y"].value)
		elif orientation == 'top':

			SearchY = MenuHeight -  int(SBase[0].attributes["Y"].value) - SearchH
		else:
			SearchY = int(SBase[0].attributes["Y"].value)
		# Load theme-only values
		if SearchWidget == "Custom":
			SearchIX = int(SBase[0].attributes["InsetX"].value) 
			SearchIY = int(SBase[0].attributes["InsetY"].value)
			SearchInitialText = SBase[0].attributes["InitialText"].value
			try:SearchTextColor = SBase[0].attributes["TextColor"].value
			except:SearchTextColor = "#000000"
				
			SearchBackground = SBase[0].attributes["Background"].value
			SearchWidgetPath = SBase[0].attributes["WidgetName"].value
		if SearchWidget == "Cairo":
			try:CairoSearchTextColor = SBase[0].attributes["TextColor"].value
			except:CairoSearchTextColor = "#000000"
			try:CairoSearchBackColor = SBase[0].attributes["BackColor"].value
			except:CairoSearchBackColor = "#FFFFFF"
			try:CairoSearchBorderColor = SBase[0].attributes["BorderColor"].value
			except:CairoSearchBorderColor = "#000000"				
			try:CairoSearchRoundAngle = int(SBase[0].attributes["RoundAngle"].value)
			except:CairoSearchRoundAngle = 0	

	# Load ProgramListSettings
	SBase = XBase.getElementsByTagName("ProgramListSettings")
	PG_buttonframedimensions = int(SBase[0].attributes["Width"].value),int(SBase[0].attributes["Height"].value)
	if orientation == 'botton':
		PG_buttonframe = int(SBase[0].attributes["X"].value),int(SBase[0].attributes["Y"].value)
	elif orientation == 'top':
		PG_buttonframe = int(SBase[0].attributes["X"].value),MenuHeight - int(SBase[0].attributes["Y"].value) - int(PG_buttonframedimensions[1])
	else:
		PG_buttonframe = int(SBase[0].attributes["X"].value),int(SBase[0].attributes["Y"].value)
	try:
		OnlyShowFavs = int(SBase[0].attributes["OnlyShowFavs"].value)
	except:
		OnlyShowFavs = 0
	# Load Capabilities
	SBase = XBase.getElementsByTagName("Capabilities")
	MenuHasSearch = int(SBase[0].attributes["HasSearch"].value)
	MenuHasIcon = int(SBase[0].attributes["HasIcon"].value)
	MenuHasFade = int(SBase[0].attributes["HasFadeTransition"].value)

	#Load Menu Button List
	global MenuButtonCount, MenuButtonNames, MenuButtonMarkup, MenuButtonNameOffsetX, MenuButtonNameOffsetY, MenuButtonCommands,MenuButtonX,MenuButtonY,MenuButtonImage, MenuButtonIcon, MenuButtonIconSel, MenuButtonSub,MenuButtonClose, MenuCairoIcon
	MenuButtons = XBase.getElementsByTagName("Button")
	MenuButtonCount = len(MenuButtons)	
	MenuButtonNames = []
	MenuButtonMarkup = []
	MenuButtonNameOffsetX = []
	MenuButtonNameOffsetY = []
	MenuButtonX = []
	MenuButtonY = []
	MenuButtonImage = []
	MenuButtonIcon = []
	MenuButtonIconSel = []
	MenuCairoIcon = []
	MenuButtonSub = []
	MenuButtonCommands = []
	MenuButtonClose = []
	for node in MenuButtons:

		im = gtk.gdk.pixbuf_new_from_file(ImageDirectory + node.attributes["Image"].value)
		h = im.get_height()
		
		MenuButtonNames.append(node.attributes["Name"].value)
		MenuButtonMarkup.append(node.attributes["Markup"].value)
		MenuButtonNameOffsetX.append(int(node.attributes["TextX"].value))
		MenuButtonImage.append(node.attributes["Image"].value)    	    	
		MenuButtonIcon.append(node.attributes["ButtonIcon"].value)    	    	
		MenuButtonIconSel.append(node.attributes["ButtonIconSel"].value)    	    	
		MenuCairoIcon.append(node.attributes["Icon"].value)    	    	
		MenuButtonX.append(int(node.attributes["ButtonX"].value))
		if orientation == 'botton':
			MenuButtonNameOffsetY.append(int(node.attributes["TextY"].value))
			MenuButtonY.append(int(node.attributes["ButtonY"].value))
		elif orientation == 'top':

			MenuButtonNameOffsetY.append(int(node.attributes["TextY"].value) )
			MenuButtonY.append(MenuHeight - int(node.attributes["ButtonY"].value) -h )
		else:
			MenuButtonNameOffsetY.append(int(node.attributes["TextY"].value))
			MenuButtonY.append(int(node.attributes["ButtonY"].value))

		MenuButtonCommands.append(node.attributes["Command"].value)
		MenuButtonSub.append(int(node.attributes["SubMenu"].value))
		MenuButtonClose.append(int(node.attributes["CloseMenu"].value))
	#================================================================
	#Load Menu Label List
	global MenuLabelCount, MenuLabelNames, MenuLabelMarkup,MenuLabelX,MenuLabelY,MenuLabelCommands
	MenuLabels = XBase.getElementsByTagName("Label")
	MenuLabelCount = len(MenuLabels)
	MenuLabelNames = []
	MenuLabelMarkup = []
	MenuLabelCommands = []
	MenuLabelX = []
	MenuLabelY = []
	for node in MenuLabels:
		MenuLabelNames.append(node.attributes["Name"].value)
		MenuLabelMarkup.append(node.attributes["Markup"].value)	
		MenuLabelX.append(int(node.attributes["LabelX"].value))
		if orientation == 'botton':
			MenuLabelY.append(int(node.attributes["LabelY"].value))
		elif orientation == 'top':
			MenuLabelY.append(MenuHeight - int(node.attributes["LabelY"].value) -15)
		else:
			MenuLabelY.append(int(node.attributes["LabelY"].value))
		MenuLabelCommands.append(node.attributes["Command"].value)

	#Load Menu Tab List
	global MenuTabCount, MenuTabNames, MenuTabMarkup, MenuTabNameOffsetX, MenuTabNameOffsetY, MenuTabCommands,MenuTabX,MenuTabY,MenuTabImage, MenuTabIcon, MenuTabImageSel, MenuTabSub,MenuTabClose, MenuCairoIcontab
	MenuTabs = XBase.getElementsByTagName("Tab")
	MenuTabCount = len(MenuTabs)
	MenuTabNames = []
	MenuTabMarkup = []
	MenuTabNameOffsetX = []
	MenuTabNameOffsetY = []
	MenuTabX = []
	MenuTabY = []
	MenuTabImage = []
	MenuTabIcon = []
	MenuTabImageSel = []
	MenuCairoIcontab = []
	MenuTabSub = []
	MenuTabCommands = []
	MenuTabClose = []
	for node in MenuTabs:

		try:
			im = gtk.gdk.pixbuf_new_from_file(ImageDirectory + node.attributes["Image"].value)
			h = im.get_height()
		except:
			im = gtk.gdk.pixbuf_new_from_file(ImageDirectory + node.attributes["ImageSel"].value)
			h = im.get_height()		
		MenuTabNames.append(node.attributes["Name"].value)
		MenuTabMarkup.append(node.attributes["Markup"].value)
		MenuTabNameOffsetX.append(int(node.attributes["TextX"].value))
		MenuTabImage.append(node.attributes["Image"].value)    	    	
		MenuTabImageSel.append(node.attributes["ImageSel"].value)    	    	
		MenuTabIcon.append(node.attributes["TabIcon"].value)    	    	
		MenuCairoIcontab.append(node.attributes["Icon"].value)    	    	
		MenuTabX.append(int(node.attributes["TabX"].value))
		if orientation == 'botton':
			MenuTabNameOffsetY.append(int(node.attributes["TextY"].value))
			MenuTabY.append(int(node.attributes["TabY"].value))
		elif orientation == 'top':

			MenuTabNameOffsetY.append(int(node.attributes["TextY"].value) )
			MenuTabY.append(MenuHeight - int(node.attributes["TabY"].value) -h )
		else:
			MenuTabNameOffsetY.append(int(node.attributes["TextY"].value))
			MenuTabY.append(int(node.attributes["TabY"].value))

		MenuTabCommands.append(node.attributes["Command"].value)
		MenuTabSub.append(int(node.attributes["SubMenu"].value))
		MenuTabClose.append(int(node.attributes["CloseMenu"].value))
	#================================================================
	global MenuImageCount, MenuImageNames,MenuImageX,MenuImageY,MenuImage
	MenuImages = XBase.getElementsByTagName("Image")
	MenuImageCount = len(MenuImages)
	MenuImageNames = []
	MenuImageX = []
	MenuImageY = []
	MenuImage = []
	for node in MenuImages:

		im = gtk.gdk.pixbuf_new_from_file(ImageDirectory + node.attributes["Image"].value)
		h = im.get_height()
		
		MenuImageNames.append(node.attributes["Name"].value)
		MenuImage.append(node.attributes["Image"].value)    	    	
		MenuImageX.append(int(node.attributes["ImageX"].value))
		if orientation == 'botton':
			MenuImageY.append(int(node.attributes["ImageY"].value))
		elif orientation == 'top':
			MenuImageY.append(MenuHeight - int(node.attributes["ImageY"].value) -h )
		else:
			MenuImageY.append(int(node.attributes["ImageY"].value))

	#================================================================

	global ButtonHasTop, ButtonLabelCount, ButtonHasBottom,ButtonLabelName,ButtonLabelMarkup,ButtonLabelX,ButtonLabelY
	try:
		XMLSettings = xml.dom.minidom.parse(MenuButtonDirectory+"themedata.xml")
	except:
		LoadDefaults()
		XMLSettings = xml.dom.minidom.parse(MenuButtonDirectory+"themedata.xml")
	XBase = XMLSettings.getElementsByTagName("theme")

	ButtonHasTop = int(XBase[0].attributes["Top"].value)

	if ButtonHasTop==0:
		ShowTop=0
	try:
		XMLSettings = xml.dom.minidom.parse(MenuButtonDirectory+"themedata.xml")
	except:
		LoadDefaults()
		XMLSettings = xml.dom.minidom.parse(MenuButtonDirectory+"themedata.xml")
	XBase = XMLSettings.childNodes[0].childNodes[1]
	ButtonLabels = XMLSettings.getElementsByTagName("Label")
	ButtonLabelCount = len(ButtonLabels)
	ButtonLabelName = ""
	ButtonLabelMarkup = ""
	ButtonLabelX = 0
	ButtonLabelY = 0
	if ButtonLabelCount != []:
		for node in ButtonLabels:
		
			ButtonLabelName= (node.attributes["Name"].value)
			ButtonLabelMarkup = (node.attributes["MarkupNormal"].value)	
			ButtonLabelX = (int(node.attributes["LabelX"].value))
			ButtonLabelY = (int(node.attributes["LabelY"].value))



String_list = ['Start','Menu','Control Panel','Favorites','Applications','Computer','Recently Used','Recent', 'Recent Documents', 'Recent Items','Show History','History','Leave','Shutdown','Lock Screen','Lock','Lock Computer','Home Folder', 'Personal Folder' , 'Home','Network','Connect','Connect To','Connect To Server','Package Manager','Help','Power','Search','About Me','Log Out','Shutdown Computer','Run', 'Execute Application','All Applications', 'All Programs','Help And Support','Logout','System','Control Center','Install Software','Status','Programs','User','Distro','Hdd','Used']

String_list_translated = [_('Start'),_('Menu'),_('Control Panel'),_('Favorites'),_('Applications'),_('Computer'),_('Recently Used'),_('Recent'),_('Recent Documents'),_('Recent Items'),_('Show History'),_('History'),_('Leave'),_('Shutdown'),_('Lock Screen'),_('Lock'),_('Lock Computer'),_('Home Folder'),_('Personal Folder') ,_('Home'),_('Network'),_('Connect'),_('Connect To'),_('Connect To Server'),_('Package Manager'),_('Help'),_('Power'),_('Search'),_('About Me'),_('Log Out'),_('Shutdown Computer'),_('Run'),_('Execute Application'),_('All Applications'),_('All Programs'),_('Help And Support'),_('Logout'),_('System'),_('Control Center'),_('Install Software'),_('Status'),_('Programs'),_('User'),_('Distro'),_('Hdd'),_('Used')]

ReloadSettings()
#Screen width/height
__screen = gtk.gdk.screen_get_default()
geom = gtk.gdk.Screen.get_monitor_geometry(__screen, 0)
screenwidth = geom.width
screenheight = geom.height

#Basemenu parse (saves the delay everytime the menu is opened)
BaseMenu=""
# Obtain OS default icon theme
gconf_client = gconf.client_get_default()
DefaultIconTheme = gconf_client.get_string("/desktop/gnome/interface/icon_theme")

# Check compositing status
DIModule = DesktopIntegration()
EnableCompositing = int(DIModule.checkcompositing())

#This overrides user icon settings for themes that do not support them

if EnableCompositing==0:
	MenuHasFade = 0
	ShowTop = 0

#Main Start Button
#States:
# 0 = Normal
# 1 = Glowing (mouse-over)
# 2 = Depressed
              
# Blue glowy orb main
StartButton = (MenuButtonDirectory+"start-here.png",
               MenuButtonDirectory+"start-here-glow.png",
               MenuButtonDirectory+"start-here-depressed.png")
               
# Blue glowy orb top part
StartButtonTop = (MenuButtonDirectory+"start-here-top.png",
                     MenuButtonDirectory+"start-here-top-glow.png",
                     MenuButtonDirectory+"start-here-top-depressed.png",
                     MenuButtonDirectory+"start-here-bottom.png",
                     MenuButtonDirectory+"start-here-bottom-glow.png",
                     MenuButtonDirectory+"start-here-bottom-depressed.png")

StartMenuXOffset = -2
StartMenuYOffset = 0

StartMenuTextX = -2
StartMenuTextY = 0

#User Image
UserImageFrame = ImageDirectory+"user-image-frame.png"
DefaultUserImage = IconDirectory+"no-user-image.png"
UserImage = os.getenv('HOME') + "/.face"
if os.path.isfile(UserImage) == 0:
    UserImage=DefaultUserImage

#Application logo
Applogo = GraphicsDirectory +"logo.png"
BrokenImage = GraphicsDirectory + "/brokenlink.png"

#Web and Email  FIXME This is not customisable
Browser = IconDirectory+"firefox_icon.png"
Email = IconDirectory+"thunderbird_icon.png"

M_CurrentIconSet = ""
elist = []
ebuttonnamelist = []
ebuttoniconlist = []
etypelist = []
gc.collect()
        
