#!/usr/bin/env python

# This application is released under the GNU General Public License 
# v3 (or, at your option, any later version). You can find the full 
# text of the license under http://www.gnu.org/licenses/gpl.txt. 
# By using, editing and/or distributing this software you agree to 
# the terms and conditions of this license. 
# Thank you for using free software!
#
#(c) Whise 2009 <helderfraga@gmail.com>


import pygtk
pygtk.require('2.0')
import gtk
import os
import commands
import sys
import gconf
import Globals
if len(sys.argv) == 2 and sys.argv[1] == "--welcome":
	Globals.FirstUse = True
import gettext
import locale
import xml.dom.minidom

locale.setlocale (locale.LC_ALL, "")

#gettext.bindtextdomain("libgnomeui-2.0", '/usr/share/locale-langpack')

def _(s):
	gettext.textdomain("synaptic")
	gettext.install("synaptic", '/usr/share/locale-langpack')
	text = gettext.gettext(s)
	return gettext.gettext(s)


try:
	INSTALL_PREFIX = open("/etc/gnomenu/prefix").read()[:-1] 
except:
	INSTALL_PREFIX = '/usr'

#Language="en"
#IconSize=32.0
#Compositing="1"
#ListSize=10.0
#SuperL=1
#Style_Name="Kore"
#Menu_Name="Kore"
#Color="white"
#Icon_Name="Newstyles"
#Button_Name="Gnome"
#ShowTop="1"
#Widget_Name="Classic"
#Animation_TransitionQ="0.05"
#Animation_TransitionS="40"
#Shownetandemail="1"
#GtkColors="0"
#Search="tracker-search-tool"
#Network_Config ="nm-connection-editor"
#Control_Panel ="gnome-control-center"
#Package_Manager ="gksu synaptic"
#Help ="yelp"
#Power ="gnome-session-save --shutdown-dialog"
#Lock ="gnome-screensaver-command --lock"
#Run ="/usr/lib/gnomenu/Gnome_run_dialog.py"

class GnoMenuSettings:


	def delete(self, widget, event=None):
		gtk.main_quit()
		return False

	def __init__(self):
		self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
		self.window.connect("delete_event", self.delete)
		self.window.set_border_width(10)
		self.load_settings
		# Create a new notebook
		self.notebook = gtk.Notebook()
		self.vbox = gtk.VBox()
		self.vbox.pack_start(self.notebook, True, True)
		self.window.add(self.vbox)
		self.window.set_position(gtk.WIN_POS_CENTER)
		self.notebook.show()

		# Add some tab pages for demonstrating
		#for i in range(2):
		
		# TAB 1

		self.frame1 = gtk.Frame(_('Menu Selection'))
		self.frame1.set_border_width(5)
		self.vbox1 = gtk.VBox()
		self.vbox1.set_border_width(5)
		self.vbox1.pack_start(self.frame1, True, True)
		self.vbox3 = gtk.VBox()

		self.image1 = gtk.Image()
		try:
			Pixbuf = gtk.gdk.pixbuf_new_from_file_at_size(Globals.ThemeDirectory  + "Menu/" + Globals.Theme + "/themepreview.png",150,230)
		except:
			Pixbuf = gtk.gdk.pixbuf_new_from_file(Globals.GraphicsDirectory + "theme.png")
		self.hboxa1 = gtk.HBox()
		XMLCredits = xml.dom.minidom.parse(Globals.ThemeDirectory  + "Menu/" + Globals.Theme + "/" + 'themedata.xml')
		XBase = XMLCredits.childNodes[0]
		SBase = XBase.getElementsByTagName("ContentData")

		Name = SBase[0].attributes["Name"].value
		Author = SBase[0].attributes["Author"].value
		Right = SBase[0].attributes["Copyright"].value
		self.labela1 = gtk.Label(Name + ' by: ' + Author + '\n\n' + Right)
		self.labela1.set_size_request(150,-1)
		self.labela1.set_line_wrap(True)
		self.hboxa1.pack_start(self.image1, True, True)
		self.hboxa1.pack_start(self.labela1, True, True)
		self.image1.set_from_pixbuf(Pixbuf)
		self.vbox3.pack_start(self.hboxa1, True, True)
		self.hbox_c1 = gtk.HBox()
		self.but1 = gtk.Button(_('Install'))
		self.but1.connect('clicked', self.button_clicked, 'install_menu')
		self.but1.set_image(gtk.image_new_from_stock(gtk.STOCK_ADD, 
			gtk.ICON_SIZE_BUTTON))
		self.but2 = gtk.Button(_('Uninstall'))
		self.but2.connect('clicked', self.button_clicked, 'uninstall_menu')
		self.but2.set_image(gtk.image_new_from_stock(gtk.STOCK_REMOVE, 
			gtk.ICON_SIZE_BUTTON))
		self.combo1 = gtk.combo_box_new_text()
		self.hbox_c1.pack_start(self.but1, False, False)
		self.hbox_c1.pack_start(self.but2, False, False)
		self.hbox_c1.pack_start(self.combo1, True, True)
		themes = os.listdir(INSTALL_PREFIX + '/share/gnomenu/Themes/'+ "Menu" + '/')
		themes.sort()
		x = 0
		for folder in themes: 
			try:
				Pixbuf = gtk.gdk.pixbuf_new_from_file_at_size(Globals.ThemeDirectory + "/" + "Menu" +"/" + folder + "/themepreview.png",64,64)
			except:
				Pixbuf = gtk.gdk.pixbuf_new_from_file(Globals.GraphicsDirectory + "theme.png")
			self.combo1.append_text(folder)
			
			if folder == Globals.Theme:
				self.combo1.set_active(x)
			x = x + 1
		self.combo1.connect("changed",self.redraw_image, 'Menu')
		self.vbox3.pack_start(self.hbox_c1, False, False)
		self.frame1.add(self.vbox3)



		self.frame2 = gtk.Frame(_('Button Selection'))
		self.vbox1.pack_start(self.frame2, True, True)
		self.vbox5 = gtk.VBox()
		
		self.image2 = gtk.Image()
		try:
			Pixbuf = gtk.gdk.pixbuf_new_from_file_at_size(Globals.ThemeDirectory  + "Button/" + Globals.MenuButtonTheme + "/themepreview.png",64,150)
		except:
			Pixbuf = gtk.gdk.pixbuf_new_from_file(Globals.GraphicsDirectory + "theme.png")
		self.hboxa2 = gtk.HBox()
		XMLCredits = xml.dom.minidom.parse(Globals.ThemeDirectory  + "Button/" + Globals.MenuButtonTheme + "/" + 'themedata.xml')
		XBase = XMLCredits.childNodes[0]
		SBase = XBase.getElementsByTagName("ContentData")

		Name = SBase[0].attributes["Name"].value
		Author = SBase[0].attributes["Author"].value
		Right = SBase[0].attributes["Copyright"].value
		self.labela2 = gtk.Label(Name + ' by: ' + Author + '\n\n' + Right)
		self.labela2.set_size_request(150,-1)
		self.labela2.set_line_wrap(True)
		self.hboxa2.pack_start(self.image2, True, True)
		self.hboxa2.pack_start(self.labela2, True, True)
		self.image2.set_from_pixbuf(Pixbuf)
		self.vbox5.pack_start(self.hboxa2, True, True)
		self.hbox_c2 = gtk.HBox()
		self.but3 = gtk.Button(_('Install'))
		self.but3.connect('clicked', self.button_clicked, 'install_but')
		self.but3.set_image(gtk.image_new_from_stock(gtk.STOCK_ADD, 
			gtk.ICON_SIZE_BUTTON))
		self.but4 = gtk.Button(_('Uninstall'))
		self.but4.connect('clicked', self.button_clicked, 'uninstall_but')
		self.but4.set_image(gtk.image_new_from_stock(gtk.STOCK_REMOVE, 
			gtk.ICON_SIZE_BUTTON))
		self.combo2 = gtk.combo_box_new_text()
		self.hbox_c2.pack_start(self.but3, False, False)
		self.hbox_c2.pack_start(self.but4, False, False)
		self.hbox_c2.pack_start(self.combo2, True, True)
		themes = os.listdir(INSTALL_PREFIX + '/share/gnomenu/Themes/'+ "Button" + '/')
		themes.sort()
		x = 0
		for folder in themes: 
			try:
				Pixbuf = gtk.gdk.pixbuf_new_from_file_at_size(Globals.ThemeDirectory + "/" + "Button" +"/" + folder + "/themepreview.png",64,64)
			except:
				Pixbuf = gtk.gdk.pixbuf_new_from_file(Globals.GraphicsDirectory + "theme.png")
			#Dataset.append([Name,Folder,Pixbuf])
			self.combo2.append_text(folder)
			if folder == Globals.MenuButtonTheme:
				self.combo2.set_active(x)
			x = x + 1
		self.combo2.connect("changed",self.redraw_image, 'Button')
		self.vbox5.pack_start(self.hbox_c2, False, False)
		self.frame2.add(self.vbox5)




		self.frame3 = gtk.Frame(_('Icon Selection'))
		self.vbox1.pack_start(self.frame3, True, True)
		self.vbox6 = gtk.VBox()
		
		self.image3 = gtk.Image()
		try:
			Pixbuf = gtk.gdk.pixbuf_new_from_file_at_size(Globals.ThemeDirectory  + "Icon/" + Globals.IconTheme + "/themepreview.png",64,150)
		except:
			Pixbuf = gtk.gdk.pixbuf_new_from_file(Globals.GraphicsDirectory + "theme.png")
		self.hboxa3 = gtk.HBox()
		XMLCredits = xml.dom.minidom.parse(Globals.ThemeDirectory  + "Icon/" + Globals.IconTheme + "/" + 'themedata.xml')
		XBase = XMLCredits.childNodes[0]
		SBase = XBase.getElementsByTagName("ContentData")

		Name = SBase[0].attributes["Name"].value
		Author = SBase[0].attributes["Author"].value
		Right = SBase[0].attributes["Copyright"].value
		self.labela3 = gtk.Label(Name + ' by: ' + Author + '\n\n' + Right)
		self.labela3.set_size_request(150,-1)
		self.labela3.set_line_wrap(True)
		self.hboxa3.pack_start(self.image3, True, True)
		self.hboxa3.pack_start(self.labela3, True, True)
		self.image3.set_from_pixbuf(Pixbuf)
		self.vbox6.pack_start(self.hboxa3, True, True)
		self.hbox_c3 = gtk.HBox()
		self.but5 = gtk.Button(_('Install'))
		self.but5.connect('clicked', self.button_clicked, 'install_ico')
		self.but5.set_image(gtk.image_new_from_stock(gtk.STOCK_ADD, 
			gtk.ICON_SIZE_BUTTON))
		self.but6 = gtk.Button(_('Uninstall'))
		self.but6.connect('clicked', self.button_clicked, 'uninstall_ico')
		self.but6.set_image(gtk.image_new_from_stock(gtk.STOCK_REMOVE, 
			gtk.ICON_SIZE_BUTTON))
		self.combo3 = gtk.combo_box_new_text()
		self.hbox_c3.pack_start(self.but5, False, False)
		self.hbox_c3.pack_start(self.but6, False, False)
		self.hbox_c3.pack_start(self.combo3, True, True)
		themes = os.listdir(INSTALL_PREFIX + '/share/gnomenu/Themes/'+ "Icon" + '/')
		themes.sort()
		x = 0
		for folder in themes: 
			try:
				Pixbuf = gtk.gdk.pixbuf_new_from_file_at_size(Globals.ThemeDirectory + "/" + "Icon" +"/" + folder + "/themepreview.png",64,64)
			except:
				Pixbuf = gtk.gdk.pixbuf_new_from_file(Globals.GraphicsDirectory + "theme.png")
			#Dataset.append([Name,Folder,Pixbuf])
			self.combo3.append_text(folder)
			if folder == Globals.IconTheme:
				self.combo3.set_active(x)
			x = x + 1
		self.combo3.connect("changed",self.redraw_image, 'Icon')
		self.vbox6.pack_start(self.hbox_c3, False, False)
		self.frame3.add(self.vbox6)
		self.image1.set_size_request(100,230)
		self.image2.set_size_request(64,64)
		self.image3.set_size_request(64,64)
		#self.notebook2.append_page(self.vbox3)
		#self.notebook2.append_page(self.vbox3)
		#self.notebook2.append_page(self.vbox3)
		#frame.set_border_width(10)
		#frame.set_size_request(100, 75)
		#frame.show()
		#label = gtk.Label("Inside of Frame %d" % page_number)
		#frame.add(label)
		#label.show()

		# TAB 2
		self.vbox2 = gtk.VBox()
		self.vbox2.set_size_request(400, 475)		
		self.frame4 = gtk.Frame(_('Settings'))
		self.frame5 = gtk.Frame(_('Builtin Commands'))
		self.vbox7 = gtk.VBox()
		self.vbox7.set_border_width(10)
		self.frame4.add(self.vbox7)
		self.vbox2.pack_start(self.frame4, False, False)
		self.vbox2.pack_start(self.frame5, False, False)
		self.check1 = gtk.CheckButton(_('Bind keyboad Super L'))
		self.check1.set_active(int(Globals.SuperL))
		self.check2 = gtk.CheckButton(_('Show Internet and Email Buttons'))
		self.check2.set_active(int(Globals.Shownetandemail))
		self.check3 = gtk.CheckButton(_('Use Gtk Theme Colors in Program List'))
		self.check3.set_active(int(Globals.GtkColors))
		self.check4 = gtk.CheckButton(_('Tab Selection on Mouse Hover'))
		self.check4.set_active(int(Globals.TabHover))
		self.hbox12 = gtk.HBox()
		self.hbox13 = gtk.HBox()
		self.label11 = gtk.Label(_(' Icon Size in Program List'))
		self.label12 = gtk.Label(_(' Number of Items in Recent Items List'))
		self.spinbutton1 = gtk.SpinButton()
		self.spinbutton1.set_digits(1)
		self.spinbutton1.set_increments(1, int(256))
		self.spinbutton1.set_range(16, 256)
		self.spinbutton1.set_value(Globals.IconSize)
		#self.spinbutton1.connect("value-changed", self.options_callback, option)
		self.spinbutton2 = gtk.SpinButton()
		self.spinbutton2.set_digits(1)
		self.spinbutton2.set_increments(1, int(100))
		self.spinbutton2.set_range(1, 50)
		self.spinbutton2.set_value(Globals.ListSize)
		self.hbox12.pack_start(self.spinbutton1, False, False)
		self.hbox12.pack_start(self.label11, False, False)
		self.hbox13.pack_start(self.spinbutton2, False, False)
		self.hbox13.pack_start(self.label12, False, False)
		#self.spinbutton1.connect("value-changed", self.options_callback, option)

		self.vbox7.pack_start(self.check1, False, False)
		self.vbox7.pack_start(self.check2, False, False)
		self.vbox7.pack_start(self.check3, False, False)
		self.vbox7.pack_start(self.check4, False, False)
		self.vbox7.pack_start(self.hbox12, False, False)
		self.vbox7.pack_start(self.hbox13, False, False)
		self.vbox8 = gtk.VBox()
		self.vbox8.set_border_width(10)
		self.frame5.add(self.vbox8)


		self.hbox2 = gtk.HBox()
		self.hbox2.set_border_width(5)
		self.label1 = gtk.Label(_('Search'))
		self.label1.set_size_request(50,-1)
		self.entry1 = gtk.Entry()
		self.entry1.set_text(Globals.Search)
		self.hbox2.pack_start(self.label1, True, True)
		self.hbox2.pack_start(self.entry1, True,True)
		
		self.hbox4 = gtk.HBox()
		self.hbox4.set_border_width(5)
		self.label3 = gtk.Label(_('Network Config'))
		self.label3.set_size_request(50,-1)
		self.entry3 = gtk.Entry()
		self.entry3.set_text(Globals.Network_Config)
		self.hbox4.pack_start(self.label3, True, True)
		self.hbox4.pack_start(self.entry3, True,True)

		self.hbox5 = gtk.HBox()
		self.hbox5.set_border_width(5)
		self.label4 = gtk.Label(_('Control Panel'))
		self.label4.set_size_request(50,-1)
		self.entry4 = gtk.Entry()
		self.entry4.set_text(Globals.Control_Panel)
		self.hbox5.pack_start(self.label4, True, True)
		self.hbox5.pack_start(self.entry4, True,True)

		self.hbox6 = gtk.HBox()
		self.hbox6.set_border_width(5)
		self.label5 = gtk.Label(_('Package Manager'))
		self.label5.set_size_request(50,-1)
		self.entry5 = gtk.Entry()
		self.entry5.set_text(Globals.Package_Manager)
		self.hbox6.pack_start(self.label5, True, True)
		self.hbox6.pack_start(self.entry5, True,True)

		self.hbox7 = gtk.HBox()
		self.hbox7.set_border_width(5)
		self.label6 = gtk.Label(_('Help'))
		self.label6.set_size_request(50,-1)
		self.entry6 = gtk.Entry()
		self.entry6.set_text(Globals.Help)
		self.hbox7.pack_start(self.label6, True, True)
		self.hbox7.pack_start(self.entry6, True,True)

		self.hbox8 = gtk.HBox()
		self.hbox8.set_border_width(5)
		self.label7 = gtk.Label(_('Shutdown Dialog'))
		self.label7.set_size_request(50,-1)
		self.entry7 = gtk.Entry()
		self.entry7.set_text(Globals.Power)
		self.hbox8.pack_start(self.label7, True, True)
		self.hbox8.pack_start(self.entry7, True,True)

		self.hbox9 = gtk.HBox()
		self.hbox9.set_border_width(5)
		self.label8 = gtk.Label(_('Lock Screen'))
		self.label8.set_size_request(50,-1)
		self.entry8 = gtk.Entry()
		self.entry8.set_text(Globals.Lock)
		self.hbox9.pack_start(self.label8, True, True)
		self.hbox9.pack_start(self.entry8, True,True)

		self.hbox10= gtk.HBox()
		self.hbox10.set_border_width(5)
		self.label9 = gtk.Label(_('Logout'))
		self.label9.set_size_request(50,-1)
		self.entry9 = gtk.Entry()
		self.entry9.set_text(Globals.Logout)
		self.hbox10.pack_start(self.label9, True, True)
		self.hbox10.pack_start(self.entry9, True,True)

		self.hbox3 = gtk.HBox()
		self.hbox3.set_border_width(5)
		self.label2 = gtk.Label(_('Restart'))
		self.label2.set_size_request(50,-1)
		self.entry2 = gtk.Entry()
		self.entry2.set_text(Globals.Restart)
		self.hbox3.pack_start(self.label2, True, True)
		self.hbox3.pack_start(self.entry2, True,True)




		self.vbox8.pack_start(self.hbox2, False, False)
		self.vbox8.pack_start(self.hbox4, False, False)
		self.vbox8.pack_start(self.hbox5, False, False)
		self.vbox8.pack_start(self.hbox6, False, False)
		self.vbox8.pack_start(self.hbox7, False, False)
		self.vbox8.pack_start(self.hbox8, False, False)
		self.vbox8.pack_start(self.hbox9, False, False)
		self.vbox8.pack_start(self.hbox10, False, False)
		#self.vbox8.pack_start(self.hbox11, False, False)
		self.vbox8.pack_start(self.hbox3, False, False)


		# TAB 3

		self.vbox9 = gtk.VBox()
		self.image_logo = gtk.Image()
		self.image_logo.set_size_request(80,80)
		self.image_logo.set_from_file(Globals.Applogo)
		self.label_credits = gtk.Label(_("GnoMenu " +Globals.version + "\n\nConsolidated menu for the GNOME desktop.\nBy Helder Fraga aka Whise <helderfraga@gmail.com>\n Please Donate"))
		self.label_credits.set_justify(gtk.JUSTIFY_CENTER)
		self.button3 = gtk.Button(_('Donate'))
		self.button3.set_border_width(5)
		self.button3.connect('clicked', self.button_clicked, 'Donate')
		self.button4 = gtk.Button(_('Download More Themes'))
		self.button4.set_border_width(5)
		self.button4.connect('clicked', self.button_clicked, 'Download')
		self.button5 = gtk.Button(_('Report Bug'))
		self.button5.set_border_width(5)
		self.button5.connect('clicked', self.button_clicked, 'Bug')
		self.button6 = gtk.Button(_('Help Translate'))
		self.button6.set_border_width(5)
		self.button6.connect('clicked', self.button_clicked, 'Translate')
		self.button7 = gtk.Button(_('Visit Homepage'))
		self.button7.set_border_width(5)
		self.button7.connect('clicked', self.button_clicked, 'Homepage')
		self.button8 = gtk.Button(_('Credits'))
		self.button8.set_border_width(5)
		self.button8.connect('clicked', self.button_clicked, 'Credits')
		self.vbox9.pack_start(self.image_logo, False, False)
		self.vbox9.pack_start(self.label_credits, False, False)
		self.vbox9.pack_start(self.button3, False, False)
		self.vbox9.pack_start(self.button4, False, False)
		self.vbox9.pack_start(self.button5, False, False)
		self.vbox9.pack_start(self.button6, False, False)
		self.vbox9.pack_start(self.button7, False, False)
		self.vbox9.pack_start(self.button8, False, False)






		self.hbox1 = gtk.HBox()
		self.vbox.pack_end(self.hbox1, False, False)


		self.button1 = gtk.Button(_('Ok'))
		self.button1.connect("clicked", self.buttonpress,'ok')
		self.button2 = gtk.Button(_('Cancel'))
		self.button2.connect('clicked', self.buttonpress,'cancel')
		self.hbox1.pack_start(self.button2, True, True)
		self.hbox1.pack_end(self.button1, True, True)

		self.label_tab1 = gtk.Label(_('Themes'))
		self.label_tab2 = gtk.Label(_('Preferences'))
		self.label_tab3 = gtk.Label(_('About'))
		self.notebook.append_page(self.vbox1,self.label_tab1)
		self.notebook.append_page(self.vbox2,self.label_tab2)
		self.notebook.append_page(self.vbox9,self.label_tab3)

		# Set what page to start at (page 4)
		
		self.window.show_all()
		if len(sys.argv) == 2 and sys.argv[1] == "--about":
			self.notebook.set_current_page(2)


	def buttonpress(self,widget,id):
		if id == 'ok':
			self.SaveSettings()
			if self.show_question('Menu needs to restart , restart now?') == True:
				x = commands.getoutput("""ps axo "%p,%a" | grep "GnoMenu" | grep -v grep|cut -d',' -f1""")
				os.system('kill -9 ' + x)

		elif id == 'cancel':
			pass
		gtk.main_quit()
	
	def button_clicked (self, widget, id):



		if id == 'Donate':
			os.system('xdg-open http://gnome-look.org/content/donate.php?content=93057 &')
		elif id == 'Download':
			os.system('xdg-open http://gnome-look.org/index.php?xcontentmode=189 &')
		elif id == 'Bug':
			os.system('xdg-open https://bugs.launchpad.net/gnomenu &')
		elif id == 'Translate':
			os.system('xdg-open https://translations.launchpad.net/gnomenu/trunk &')
		elif id == 'Homepage':
			os.system('xdg-open https://launchpad.net/gnomenu &')

		elif id == 'Credits':
			import gnome.ui
			self.Applogo = gtk.gdk.pixbuf_new_from_file(Globals.Applogo)
			about = gnome.ui.About(Globals.name,Globals.version,"GPL","Consolidated menu for the GNOME desktop.",["Helder Fraga aka Whise <helderfraga@gmail.com>" , "original version by Chris Hughes (aka. qb89dragon) <hughescih@hotmail.com>"],["Nobody."],"https://translations.launchpad.net/gnomenu/trunk/+pots/gnomenu", self.Applogo)
			about.show()
		elif id == 'install_menu':
			self.show_install_dialog(self.combo1)
		elif id == 'install_ico':
			self.show_install_dialog(self.combo3)
		elif id == 'install_but':
			self.show_install_dialog(self.combo2)
		elif id == 'uninstall_menu':
			self.show_uninstall_dialog('Menu',self.combo1)
		elif id == 'uninstall_ico':
			self.show_uninstall_dialog('Icon',self.combo3)
		elif id == 'uninstall_but':
			self.show_uninstall_dialog('Button',self.combo2)





	def redraw_image(self,widget,id):

		if id == 'Menu':
			try:
				Pixbuf = gtk.gdk.pixbuf_new_from_file_at_size(Globals.ThemeDirectory  + "Menu/" + widget.get_active_text() + "/themepreview.png",150,230)
			except:
				Pixbuf = gtk.gdk.pixbuf_new_from_file(Globals.GraphicsDirectory + "theme.png")
			XMLCredits = xml.dom.minidom.parse(Globals.ThemeDirectory  + "Menu/" + widget.get_active_text() + "/" + 'themedata.xml')
			XBase = XMLCredits.childNodes[0]
			SBase = XBase.getElementsByTagName("ContentData")
	
			Name = SBase[0].attributes["Name"].value
			Author = SBase[0].attributes["Author"].value
			Right = SBase[0].attributes["Copyright"].value
			self.labela1.set_text(Name + ' by: ' + Author + '\n\n' + Right)
			self.image1.set_from_pixbuf(Pixbuf)
		elif id == 'Button':
			try:
				Pixbuf = gtk.gdk.pixbuf_new_from_file_at_size(Globals.ThemeDirectory  + "Button/" + widget.get_active_text() + "/themepreview.png",64,64)
			except:
				Pixbuf = gtk.gdk.pixbuf_new_from_file(Globals.GraphicsDirectory + "theme.png")
			XMLCredits = xml.dom.minidom.parse(Globals.ThemeDirectory  + "Button/" + widget.get_active_text() + "/" + 'themedata.xml')
			XBase = XMLCredits.childNodes[0]
			SBase = XBase.getElementsByTagName("ContentData")
	
			Name = SBase[0].attributes["Name"].value
			Author = SBase[0].attributes["Author"].value
			Right = SBase[0].attributes["Copyright"].value
			self.labela2.set_text(Name + ' by: ' + Author + '\n\n' + Right)
			self.image2.set_from_pixbuf(Pixbuf)
		elif id == 'Icon':
			try:
				Pixbuf = gtk.gdk.pixbuf_new_from_file_at_size(Globals.ThemeDirectory  + "Icon/" + widget.get_active_text() + "/themepreview.png",64,64)
			except:
				Pixbuf = gtk.gdk.pixbuf_new_from_file(Globals.GraphicsDirectory + "theme.png")
			XMLCredits = xml.dom.minidom.parse(Globals.ThemeDirectory  + "Icon/" + widget.get_active_text() + "/" + 'themedata.xml')
			XBase = XMLCredits.childNodes[0]
			SBase = XBase.getElementsByTagName("ContentData")
	
			Name = SBase[0].attributes["Name"].value
			Author = SBase[0].attributes["Author"].value
			Right = SBase[0].attributes["Copyright"].value
			self.labela3.set_text(Name + ' by: ' + Author + '\n\n' + Right)
			self.image3.set_from_pixbuf(Pixbuf)
		self.image1.set_size_request(100,230)
		self.image2.set_size_request(64,64)
		self.image3.set_size_request(64,64)


	def show_question (self,message, title=''):
		md = gtk.MessageDialog(None, type=gtk.MESSAGE_QUESTION, 
				buttons=gtk.BUTTONS_YES_NO)
		md.set_title('?')
		md.set_markup(message)
		response = md.run()
		md.destroy()
		if response == gtk.RESPONSE_YES:
			return True
		return False

	def show_message (self,message, title=''):
	
		md = gtk.MessageDialog(None, type=gtk.MESSAGE_INFO, 
				buttons=gtk.BUTTONS_OK)
		md.set_title(title)
		md.set_markup(message)
		md.run()
		md.destroy()

	def show_uninstall_dialog (self,typ,data):
		if self.show_question('Uninstall ' + typ + ' theme ' + data.get_active_text()) == True:
			install_prefix = 'gksu '
			print chr(34) + chr(39)+'rm -rf '+Globals.ThemeDirectory +  typ + "/" + data.get_active_text()+ chr(39)+chr(34)
			#Globals.ThemeDirectory  + CurrentTreeDataSet +"/" + Dataset[Index][1]
			os.system(install_prefix +chr(34) +'rm -rf '+ chr(39)+Globals.ThemeDirectory  + typ + "/" + data.get_active_text()+ chr(39)+chr(34))

			data.remove_text(data.get_active())
			data.set_active(0)			
		
	def show_install_dialog (self,data):
		"""Craete/Show the install-dialog."""
		# create filte
		flt = gtk.FileFilter()
		flt.add_pattern('*.tar.bz2')
		flt.add_pattern('*.tar.gz')
		flt.add_pattern('*.tar')
		# create dialog
		dlg = gtk.FileChooserDialog(buttons=(gtk.STOCK_CANCEL, 
				gtk.RESPONSE_CANCEL, gtk.STOCK_OPEN, gtk.RESPONSE_OK))
		dlg.set_current_folder(os.environ['HOME'])
		dlg.set_title(_('Install a new theme'))
		dlg.set_filter(flt)
		# run
		resp		= dlg.run()
		filename	= dlg.get_filename()
		dlg.destroy()
		if resp == gtk.RESPONSE_OK:
			# create new installer
			
			# try installing and show result dialog
			self.window.window.set_cursor(gtk.gdk.Cursor(gtk.gdk.WATCH))
			self.install (filename,data)	
			self.window.window.set_cursor(gtk.gdk.Cursor(gtk.gdk.LEFT_PTR))
			

	def install(self,filename,data):
		base	= os.path.basename(filename)
		ext		= str(filename)[len(str(filename)) -3:]
		# prepend "tar." if we have a bz2 or gz archive
		tar_opts = 'xfz'
		if ext == 'bz2':
			tar_opts = 'xfj'
		if not os.path.isdir('/tmp/gnomenu/'):
			os.system('mkdir ' + '/tmp/gnomenu/')
		tmpdir = '/tmp/gnomenu/'
		os.system('tar %s %s -C %s' % (tar_opts, chr(34)+filename+chr(34), tmpdir))
		for d in os.listdir(tmpdir) : #for each item in folders
	
			if os.path.exists(tmpdir + d) and os.path.isdir(tmpdir + d): 
				
				name = d
		try:
			XMLBase = xml.dom.minidom.parse('/tmp/gnomenu/'+ name+"/themedata.xml")
		except:
			self.show_message(_('Error - theme not installed\nMaybe the Theme was packaged incorrectly\nTry to install the Theme manually'))
			os.system('rm -rf /tmp/gnomenu')
			return
		#XBase = XMLBase.childNodes[0]
		try:
			SBase = XMLBase.getElementsByTagName("content")
			type = SBase[0].attributes["type"].value
		except:
			
			self.show_message(_('Error - theme not installed\nMaybe the Theme was packaged incorrectly\nTry to install the Theme manually'))
			os.system('rm -rf /tmp/gnomenu')
			return
		
		try:
			print type
		except:
			self.show_message(_('Error - theme not installed\nMaybe the Theme was packaged incorrectly\nTry to install the Theme manually'))
			os.system('rm -rf /tmp/gnomenu')
			return
		install_dir = INSTALL_PREFIX + '/share/gnomenu/Themes/' + type + '/'
		if self.is_installed(type + '/' + name):
			if self.show_question(_('Theme exists. Continue?')) == False:
				os.system('rm -rf /tmp/gnomenu')
				return
		
		install_prefix = 'gksu '
		os.system(install_prefix +chr(34) +'tar '+tar_opts+' '+ chr(39)+ filename + chr(39)+ ' -C ' + chr(39) + install_dir + chr(39)+chr(34))
		if self.is_installed(type + '/' + name):
			data.append_text(name)
			self.show_message(_('Theme installed'))
		else:
			self.show_message(_('Error - theme not installed\nMaybe the Theme was packaged incorrectly\nTry to install the Theme manually'))
		os.system('rm -rf /tmp/gnomenu')
	

	def load_settings(self):
		pass
	
	def is_installed (self,name):
		return os.path.isdir(Globals.ThemeDirectory +  name)


	def SaveSettings(self):


		gconf_client = gconf.client_get_default()
		gconf_client.set_string(Globals.gconf_app_key + "/Menu_Name",self.combo1.get_active_text())
		gconf_client.set_int(Globals.gconf_app_key + "/IconSize",int(self.spinbutton1.get_value()))
		gconf_client.set_int(Globals.gconf_app_key + "/ListSize",int(self.spinbutton2.get_value()))
		gconf_client.set_int(Globals.gconf_app_key + "/SuperL",int(self.check1.get_active()))
		gconf_client.set_string(Globals.gconf_app_key + "/Icon_Name",self.combo3.get_active_text())
		gconf_client.set_string(Globals.gconf_app_key + "/Button_Name",self.combo2.get_active_text())
		gconf_client.set_int(Globals.gconf_app_key + "/Shownetandemail",int(self.check2.get_active()))
		gconf_client.set_int(Globals.gconf_app_key + "/GtkColors",int(self.check3.get_active()))
		gconf_client.set_int(Globals.gconf_app_key + "/TabHover",int(self.check4.get_active()))
		gconf_client.set_string(Globals.gconf_app_key + "/Search",self.entry1.get_text())
		gconf_client.set_string(Globals.gconf_app_key + "/Network_Config",self.entry3.get_text())
		gconf_client.set_string(Globals.gconf_app_key + "/Control_Panel",self.entry4.get_text())
		gconf_client.set_string(Globals.gconf_app_key + "/Package_Manager",self.entry5.get_text())
		gconf_client.set_string(Globals.gconf_app_key + "/Help", self.entry6.get_text())
		gconf_client.set_string(Globals.gconf_app_key + "/Power",self.entry7.get_text())
		gconf_client.set_string(Globals.gconf_app_key + "/Lock",self.entry8.get_text())
		gconf_client.set_string(Globals.gconf_app_key + "/Logout",self.entry9.get_text())
		gconf_client.set_string(Globals.gconf_app_key + "/Restart",self.entry2.get_text())		
	

def main():
	gtk.main()
	return 0

if __name__ == "__main__":
	GnoMenuSettings()
	main()

