#!/usr/bin/env python

# This application is released under the GNU General Public License 
# v3 (or, at your option, any later version). You can find the full 
# text of the license under http://www.gnu.org/licenses/gpl.txt. 
# By using, editing and/or distributing this software you agree to 
# the terms and conditions of this license. 
# Thank you for using free software!
#
#(c) QB89Dragon 2007/8 <hughescih@hotmail.com>
#(c) Whise 2008 <helderfraga@gmail.com>
#
# Panel Applet Code for Menu


import gnomeapplet
import gtk
import pygtk
pygtk.require('2.0')
import sys
import gobject
import gnome.ui
import commands
import pango

try:
	INSTALL_PREFIX = open("/etc/gnomenu/prefix").read()[:-1] 
except:
	INSTALL_PREFIX = '/usr'

import os.path
import gconf
import cairo
#import gconf
import re
import Globals
from Menu_Main import Main_Menu
from Panel_Top import PanelTopWindow




class GnoMenu(gnomeapplet.Applet):
	global Button_state
	def __init__(self,applet):
		#Initialise Menus
		#ConstructMainMenu()
		#self.__gobject_init__()
		
		self.timeout_interval = 200
		self.panel_size = 24
		self.tooltip_text = "Consolidated menu for the Gnome desktop"
		# Initialise Gnome
		gnome.init(Globals.name, Globals.version)

		# Initialise Button
		self.Button_state = 0

		# 0 = No change  1 = Mouse over  2 = Depressed
		# Initialise GTK Interface
		self.propxml="""
		<popup name="button3">
		<menuitem name="Item 1" verb="Props" label="_Preferences..." pixtype="stock" pixname="gtk-properties"/>
		<menuitem name="Item 2" verb="About" label="_About..." pixtype="stock" pixname="gnome-stock-about"/>
		<menuitem name="Item 3" verb="Edit" label="_Edit Menus..." pixtype="stock" pixname="alacarte"/>
		</popup>
		"""

		self.verbs = [ ( "Props", self.properties ),
					   ( "About", self.about_info ),
					   ( "Edit", self.edit_menus)  
				 ]

		self.applet = applet
		#print self.applet.get_size()
      		gtk.rc_parse_string ("""
	               style \"GnoMenu-style\"
	               {
	                 GtkWidget::focus-line-width = 0
	                 GtkWidget::focus-padding = 0
	               }
	               widget \"*.GnoMenu\" style \"GnoMenu-style\"
	               """)
	        self.applet.set_name("GnoMenu")
		self.gconf_client = gconf.client_get_default()
		self.panel_id = None
		self.orientation = None
		self.position = 0
		self.gconfkey = self.applet.get_preferences_key()
		if self.gconfkey != None:
			self.gconfkey = str(self.gconfkey).replace('/prefs','')
			self.panel_id = self.gconf_client.get_string(self.gconfkey + "/toplevel_id")
			self.position = self.gconf_client.get_int(self.gconfkey + "/position")
			self.gconf_client.add_dir(self.gconfkey + "/position",gconf.CLIENT_PRELOAD_NONE)
			self.gconf_client.notify_add(self.gconfkey + "/position", self.update_panel_size)
		if self.panel_id != None:				
			self.size = self.gconf_client.get_int("/apps/panel/toplevels/" + self.panel_id + "/size")
			Globals.panel_h = self.size
			self.orientation = self.gconf_client.get_string("/apps/panel/toplevels/" + self.panel_id + "/orientation")
			Globals.orientation = self.orientation
			if self.orientation == 'top':
				Globals.flip = False
			elif self.orientation == 'bottom':
				Globals.flip = None
			self.gconf_client.add_dir("/apps/panel/toplevels/" + self.panel_id + "/size",gconf.CLIENT_PRELOAD_NONE)
			self.gconf_client.notify_add("/apps/panel/toplevels/" + self.panel_id + "/size", self.update_panel_size) 

		
		else : self.size = 30
		print self.size
		if self.orientation != self.gconf_client.get_string(Globals.gconf_app_key + '/orientation'):
			if self.orientation == None:
				self.gconf_client.set_string(Globals.gconf_app_key + '/orientation', 'bottom')
				self.gconf_client.set_int(Globals.gconf_app_key + '/size', self.size)
			else:
				self.show_message('GnoMenu needs to be restarted to fix some settings')
				self.gconf_client.set_string(Globals.gconf_app_key + '/orientation', self.orientation)
				self.gconf_client.set_int(Globals.gconf_app_key + '/size', self.size)
				sys.exit()
		try:
			self.gconf_client.set_string(Globals.gconf_app_key + '/orientation', self.orientation)
			self.gconf_client.set_int(Globals.gconf_app_key + '/size', self.size)
		except:pass
		self.applet.set_border_width(0)
		self.Main_icon_box = gtk.Fixed()
		self.applet.add(self.Main_icon_box)
		self.ev_box = gtk.EventBox()
		self.ev_box.set_border_width(0)
		#self.ev_box.connect("expose-event",self.expose)		
		self.ev_box.connect("button-press-event",self.button_press)
		self.ev_box.connect("enter-notify-event", self.select_box)
		self.ev_box.connect("leave-notify-event", self.deselect_box)#size_allocate_event
		self.ev_box.set_visible_window(0)
		# Hotkey Menu Activation
		if Globals.SuperL == 1:
	                path = str(commands.getoutput('locate _keybinder.so')).split('\n')[0]
	                if path != '':
	                        x = commands.getoutput('xmodmap')
	                        if x.find('Super_L') == '-1':
	                                os.system("xmodmap -e 'keycode 115 = Super_L'")
	                                os.system('xmodmap -e "add mod4 = Super_L"')
	                        path = path.replace('_keybinder.so','')
				try:
		                        sys.path.append(path)
		                        from _keybinder import tomboy_keybinder_bind as bindkey
		                        bindkey("Super_L", self.ToggleMenu)
		                        print 'deskbar found - binding'
				except:
		                        print 'deskbar not found - please install it for keybinding'
		self.Main_icon_box.set_border_width(0)
		self.Main_icon_box.set_size_request(-1,self.size )
		self.Main_icon_box.put(self.ev_box,0,0)
		self.image_icon = gtk.Image()

		
		im = cairo.ImageSurface.create_from_png(Globals.StartButton[self.Button_state])
		w = im.get_width()
		h = im.get_height()

		self.scale = float(self.size)/float(h)
		if Globals.ButtonLabelCount == 1:
			self.Label = gtk.Label()
			self.txt = Globals.ButtonLabelMarkup
			try:
				self.txt = self.txt.replace(Globals.ButtonLabelName,_(Globals.ButtonLabelName))
	
			except:pass
			self.Main_icon_box.put(self.Label,int(self.scale*Globals.ButtonLabelX),int(self.scale*Globals.ButtonLabelY))
			self.Label.set_size_request(-1,self.size)
			self.txt_font = self.txt[self.txt.find("font_desc='")+11:]
			self.txt_size = int(self.txt_font[:self.txt_font.find("'")].split(' ').pop())
			self.txt_all = self.txt_font.replace(str(self.txt_size),str(int(self.txt_size*self.scale)))
			self.txt = self.txt.replace(self.txt_font,self.txt_all)
			self.Label.set_markup(self.txt)	
			#print pango.PIXELS(self.Label.get_pango_context().get_font_description().get_size())
		im = None

		pixmap = gtk.gdk.pixbuf_new_from_file(Globals.StartButton[self.Button_state]).scale_simple(int(w*self.scale),self.size,gtk.gdk.INTERP_HYPER)
		if Globals.flip == False and Globals.ButtonHasTop == 1:
			
			pixmap = pixmap.flip(Globals.flip)
		self.image_icon.set_from_pixbuf(pixmap)
		# Add Image to event object

		self.ev_box.add(self.image_icon)
		self.image_icon.set_size_request(-1,self.ev_box.allocation.height)
		self.ev_box.set_size_request(-1,self.size )
		#Timeout signal
		self.callback = gobject.timeout_add(1000,self.timeout_callback)
		#Destroy signal
		self.applet.connect("destroy",self.cleanup)
		self.applet.set_background_widget(self.applet)

		#self.applet.connect("expose-event",self.expose)
		if Globals.ShowTop == 1:
			#Create auxiliary window (CAIRO)
			self.aux = PanelTopWindow()
			self.aux.aux_window.connect("enter-notify-event", self.select_box)
			self.aux.aux_window.connect("leave-notify-event", self.deselect_box)
			self.aux.aux_window.connect("button-press-event",self.button_press)

		#Show all created windows
		self.applet.show_all()

		#Show welcome screen on first run
		#Launch the welcome screen
		if Globals.FirstUse:
			os.system("/bin/sh -c " + INSTALL_PREFIX +"'/lib/"+Globals.appdirname+"/GnoMenu-Settings.py --welcome' &")
		self.old_origin = None
		self.old_size = 0
		self.x = self.position
		self.y = self.size
		self.oldx,self.oldy = 0,0

		


	def bindkey_callback(self,keybinding):
		print 'key'
		self.ToggleMenu()

	def change_orientation(self,arg1,data):
		print self.applet.get_orient()
		

	def size_allocate_event(self, widget, allocation):
		#orient = self.applet.get_orient()
		#if orient in (gnomeapplet.ORIENT_UP, gnomeapplet.ORIENT_DOWN):
		#	if self.panel_size == allocation.height:
		#		self.panel_size = allocation.height
		#else:
		#	if self.panel_size == allocation.width:
		#		self.panel_size = allocation.width
		#if self.panel_size < 23:
		#	self.panel_size = 23
		#self.show_message(self.panel_size)
		if self.size != self.old_size:
			self.applet.set_size_request(-1,self.size)
			self.Main_icon_box.set_size_request(-1,self.size)
			self.image_icon.set_size_request(-1,self.ev_box.allocation.height)
			self.ev_box.set_size_request(-1,self.size)
			self.Redraw_graphics
			if Globals.ButtonLabelCount ==1:
				self.Label.set_size_request(-1,self.size)
				self.txt = Globals.ButtonLabelMarkup
				self.txt_font = self.txt[self.txt.find("font_desc='")+11:]
				self.txt_size = int(self.txt_font[:self.txt_font.find("'")].split(' ').pop())
				self.txt_all = self.txt_font.replace(str(self.txt_size),str(int(self.txt_size*self.scale)))
				self.txt = self.txt.replace(self.txt_font,self.txt_all)
				self.Label.set_uposition(int(self.scale*Globals.ButtonLabelX),int(self.scale*Globals.ButtonLabelY))
				self.Label.set_markup(self.txt)	
				#print self.txt_all
				#while self.Label.allocation.width > self.ev_box.allocation.width:
				#	self.txt_all = self.txt_font.replace(str(self.txt_size),str(int(self.txt_size*self.scale)))
				#	self.txt = self.txt.replace(self.txt_all,int(self.txt_all)-1)
				#	self.Label.set_markup(self.txt)	
			self.old_size = self.size


	def window_moved(self):

		self.show_message(self.panel_size)

	def expose (self, widget, event):
		ctx = widget.window.cairo_create()
		# set a clip region for the expose event
		ctx.save()
		ctx.set_source_rgba(1, 1, 1, 0)
		ctx.set_operator (cairo.OPERATOR_SOURCE)
		ctx.paint()
		ctx.restore()
		ctx.rectangle(event.area.x, event.area.y,
				event.area.width, event.area.height)
		ctx.clip()
	
	def update_panel_size(self,client, connection_id, entry, args):
		
		print 'something changed'
		#self.x,self.y = self.applet.window.get_origin()
		if entry.get_key() == "/apps/panel/toplevels/" + self.panel_id + "/size":

			self.size = self.y = entry.get_value().get_int()
		elif entry.get_key() == self.gconfkey + "/position":
			self.position = self.x = entry.get_value().get_int()
		if self.x != self.oldx or self.y != self.oldy :
			if self.panel_id!= None:
				self.size = self.gconf_client.get_int("/apps/panel/toplevels/" + self.panel_id + "/size")
			
			self.Redraw_graphics()
			self.Update_Panel_Top()
			if Globals.ShowTop == 1:
				self.aux.updateimage(Globals.StartButtonTop[self.Button_state ])
			#self.hwg = Main_Menu(self.HideMenu)
			self.hwg.Adjust_Window_Dimensions(self.x,self.y)
			Globals.SavedOriginState = self.x,self.y
			self.oldx= self.x
			self.oldy= self.y	
					
		return True

	def auxdestroyed(self):	
		#Respawn point for the aux window if it has been Alt-F4ed
		if Globals.ShowTop == 1:
			#Used in this instance for providing delay for window to be created
			self.aux = PanelTopWindow()
			#self.aux.Create(self, 0)	 #Create the orb top
			self.aux.updateimage(Globals.StartButtonTop[self.Button_state ])
				

	def button_press(self,widget,event):

		if event.button == 1:
			# Remove this next line when orb top repositioning on widget move is fixed
			if Globals.ShowTop == 1:
				pass
				#self.window_moved(self.aux)
			if self.Button_state == 2:
				self.HideMenu()
				self.Button_state = 1
			else:
				self.Button_state = 2
				self.Redraw_graphics()
				self.ShowMenu()
				
			self.Redraw_graphics()
			self.Update_Panel_Top()
		elif event.button == 3:
			self.create_menu()
			
			
	def create_menu(self):
		self.applet.setup_menu(self.propxml,self.verbs,None)
			
	def about_info(self,event,data=None):
		os.system("/bin/sh -c " + INSTALL_PREFIX +"'/lib/"+Globals.appdirname+"/GnoMenu-Settings.py --about' &")

	def properties(self,event,data=None):
		#os.spawnvp(os.P_WAIT,Globals.ProgramDirectory+"GnoMenu-Settings.py",[Globals.ProgramDirectory+"GnoMenu-Settings.py"])
		os.system("/bin/sh -c '"+Globals.ProgramDirectory+"GnoMenu-Settings.py' &")
		# Fixme, reload stuff properly
		Globals.ReloadSettings()
		
	def select_box(self,widget,event):
		if self.Button_state == 0:
			self.Button_state = 1
		self.Redraw_graphics()
		
	def deselect_box(self,widget,event):
		if self.Button_state == 1:
			self.Button_state = 0
		self.Redraw_graphics()
		
	def show_message (self, message, title=''):

		md = gtk.MessageDialog(None, type=gtk.MESSAGE_INFO, 
				buttons=gtk.BUTTONS_OK)
		md.set_title(title)
		md.set_markup(str(message))
		md.run()
		md.destroy()

	def bind_with_deskbar(self):
		path = str(commands.getoutput('locate _keybinder.so')).split('\n')[0]
		if path != '':
			x = commands.getoutput('xmodmap')
			if x.find('Super_L') == '-1':
				os.system("xmodmap -e 'keycode 115 = Super_L'")
		                os.system('xmodmap -e "add mod4 = Super_L"')
			path = path.replace('_keybinder.so','')
			sys.path.append(path)
			from _keybinder import tomboy_keybinder_bind as bindkey
		        bindkey("Super_L", self.ToggleMenu)
			print 'deskbar found - binding'
		else:
			self.bind_with_custom()

	def bind_with_custom(self):
		x = commands.getoutput('xmodmap')
		if x.find('Super_L') == '-1':
			os.system("xmodmap -e 'keycode 115 = Super_L'")
			os.system('xmodmap -e "add mod4 = Super_L"')
		try:
			from Xlib.display import Display
			from Xlib import X
			from globalkeybinding import GlobalKeyBinding
			gtk.gdk.threads_init ()
			keybinding = GlobalKeyBinding ('<Alt>F11', 'Super_L')
			keybinding.connect ('activate', self.bindkey_callback)
			keybinding.grab ()
			keybinding.start ()
		except:
			if Globals.FirstUse:
				self.show_message('Please install python xlib')
			else:
				print 'Please install python xlib'
		print 'Using own key method - binding'

	def timeout_callback(self):

		self.Redraw_graphics()
		self.Update_Panel_Top()
		if Globals.ShowTop == 1:
			self.aux.updateimage(Globals.StartButtonTop[self.Button_state ])
		self.hwg = Main_Menu(self.HideMenu)
		self.hwg.Adjust_Window_Dimensions(self.x,self.y)
		Globals.SavedOriginState = self.x,self.y
		return False

		
	def cleanup(self,event):
		print "cleanup"

		self.hwg.destroy()
		if Globals.ShowTop == 1:
			Globals.ShowTop = 0
			self.aux.destroy()
		#os.system('rm ' +Globals.HomeDirectory + "/.menuiconcache.xml")
		#gtk.main_quit()
		del self.applet
	
	def edit_menus(self,event, data=None):
		os.spawnvp(os.P_WAIT,"alacarte",["alacarte"])
		#ConstructMainMenu()

	def ToggleMenu(self):
		if self.Button_state == 2:
			self.Button_state = 0
			self.Redraw_graphics()
			self.HideMenu()
		else:
			self.Button_state = 2
			self.Redraw_graphics()
			self.ShowMenu()


	def ShowMenu(self):
		# Display the start menu!!!
		origin = self.applet.window.get_origin()
		try:
			if origin != Globals.SavedOriginState:
				self.hwg.Adjust_Window_Dimensions(origin[0],origin[1])
		except:pass
		while not hasattr(self,'hwg'):
			gtk.main_iteration()
		self.hwg.show_window()

		#self.hwg.grab_focus()
	
	def HideMenu(self):
		if self.hwg:
			if self.hwg.window.window:
				if self.hwg.window.window.is_visible()== True:
					self.hwg.hide_window()

		self.Button_state = 0
		self.Redraw_graphics()

	def Redraw_graphics (self):
		self.Main_icon_box.set_size_request(-1,self.size)
		self.ev_box.set_size_request(-1,self.size)
		self.image_icon.set_size_request(-1,self.ev_box.allocation.height)
		im = cairo.ImageSurface.create_from_png(Globals.StartButton[self.Button_state])
		w = im.get_width()
		h = im.get_height()
		self.scale = float(self.size)/float(h)
		im = None
		pixmap = gtk.gdk.pixbuf_new_from_file(Globals.StartButton[self.Button_state]).scale_simple(int(w*self.scale),self.size,gtk.gdk.INTERP_HYPER)
		if Globals.flip == False and Globals.ButtonHasTop == 1:
			pixmap = pixmap.flip(Globals.flip)
			
		self.image_icon.set_from_pixbuf(pixmap)
		if Globals.ShowTop == 1:
			self.aux.updateimage(Globals.StartButtonTop[self.Button_state ])

		pixmap = None

	def Update_Panel_Top(self,widget=None, event=None):

		if Globals.ShowTop == 1:
			self.aux.updateimage(Globals.StartButtonTop[self.Button_state ])
			self.applet.queue_draw()
			self.aux.aux_window.window.set_transient_for(self.applet.window)
			self.aux.set_scale(self.scale)
			StartButtonTopHeight = self.aux.get_height()
			print "Reorientating Orb top!! (Don't let this happen too often!!)"
			Window_x =  self.x
			if self.orientation == 'top':
				Window_y =  0 + self.y
			else:
				Window_y =  Globals.screenheight - self.y - StartButtonTopHeight
			# Calculate midpoint of screen
			self.screenmidpty = int(Globals.screenheight / 2)
			# Work out orientation of panel 
			self.aux.move(Window_x,Window_y)
			self.old_size = self.size
		



