#!/usr/bin/env python

# This application is released under the GNU General Public License 
# v3 (or, at your option, any later version). You can find the full 
# text of the license under http://www.gnu.org/licenses/gpl.txt. 
# By using, editing and/or distributing this software you agree to 
# the terms and conditions of this license. 
# Thank you for using free software!
#
#(c) QB89Dragon 2007/8 <hughescih@hotmail.com>
#(c) Whise 2008 <helderfraga@gmail.com>
#
# Error message
# This does not run independently

import gtk
import gtk.glade


try:
	INSTALL_PREFIX = open("/etc/gnomenu/prefix").read()[:-1] 
except:
	INSTALL_PREFIX = '/usr'


class Message:
	def __init__(self,message,title,callbackOk=None,callbackCa=None, hidecancel=0):
		# Set the Glade file
		self.wTree = gtk.glade.XML(INSTALL_PREFIX + "/lib/gnomenu/error-message.glade")
		self.window = self.wTree.get_widget("window")
		self.window.set_app_paintable(1)
		self.window.set_skip_taskbar_hint(1)
		self.window.set_skip_pager_hint(1)
		self.window.set_keep_above(0)       #Make this always above other windows
		
		self.window.set_title(title)
		self.window.present()
		self.label = self.wTree.get_widget("errlbl")
		self.label.set_text(message)
		self.window.connect("destroy",gtk.main_quit)
		if callbackCa:
			self.button1 = self.wTree.get_widget("button1")
			self.button1.connect("button-press-event",callbackCa)
		if callbackOk:		
			self.button2 = self.wTree.get_widget("button2")
			self.button2.connect("button-press-event",callbackOk)
		if hidecancel==1:
			self.button1.hide()
		
		gtk.main()
	
#def b (widget,event):
#	print "click!"
#a = Message("Test the error message box for GnoMenu! This will not be in multi-language support because that relies on modules that have the potential to fail to load and would thus generate this error.","Test", b)
